CON

  _CLKMODE = XTAL1 + PLL16X
  _CLKFREQ = 80_000_000

  _FirstLedPin = 16
  _LastLedPin = 23
  _ArraySize = 512
  _BitPattern = %0000_0001_0000_0001_0000_0001_0000_0001
  _MinLedsAtOnce = 1
  _MaxLedsAtOnce = 8 '7
  
VAR

  long delay, bitPattern
  byte array[_ArraySize]
  byte byteValue
  
OBJ

  Mo : "MyObject110707d"
  
PUB Main | localIndex, direction, ledsAtOnce, shiftAmount

  delay := _CLKFREQ / 2'* 2 '4
  bitPattern := _BitPattern
  repeat localIndex from 0 to _ArraySize - 1
    array[localIndex] := bitPattern  ' load array with increasing byte values
                                     ' localIndex is a long but only lowest 8 signifcant bits
                                     ' are saved to array[x]
    bitPattern <-= 1                                 
  Mo.Start(@array, _ArraySize, _FirstLedPin, _LastLedPin - _FirstLedPin + 1)
                                     
  waitcnt(delay * 2 + cnt)  ' leave array alone for a couple of seconds
  
  direction := 1                ' used to increase of decrease byteValue

  shiftAmount := 1
  ledsAtOnce := _MinLedsAtOnce
  bitPattern := _BitPattern
  repeat
    
    repeat localIndex from 0 to _ArraySize - 1
      array[localIndex] := bitPattern  ' reload the array with different bytes
                                      
      bitPattern <-= shiftAmount
    shiftAmount += direction     ' change the amount each bit gets shifted
    if shiftAmount =< 0 or shiftAmount => 2 '32
      if shiftAmount == 0
        if ledsAtOnce == _MaxLedsAtOnce
          ledsAtOnce := _MinLedsAtOnce
        else
          ledsAtOnce++
        bitPattern := 0
        repeat ledsAtOnce
          bitPattern <-= 1
          bitPattern += _BitPattern 
      direction *= -1
      shiftAmount += direction
    waitcnt(delay + cnt)  ' let this pattern run for a while in MyObject
   
   